#
# depend.mk
# Makefile section to create the dependency sections
#

DependFileTmpl := $(MakeDir)/$(DependFile).tmpl
MakeDependCmd := MakeDir=$(MakeDir) DependFile=$(DependFile) \
		PackageType=$(PackageType) Packages="$(Packages)" \
		TestPackages="$(TestPackages)" $(MakeDir)/dependtmpl.sh

ifeq ($(UseFileListB),1)

$(DependFile):			# DO NOT put "FORCE" here.
	@echo "Making $(DependFile) in $(Package)"
	@$(MakeDependCmd)
	MakeDir=$(MakeDir) $(MakeDir)/dependfiles.sh >> $@

else

$(DependFile):			# DO NOT put "FORCE" here.
	@echo "Making $(DependFile) in $(Package)"
	@$(MakeDependCmd)

endif

ifeq ($(UseArchB),1)

$(ArchDependFile): $(MakeDir)/depend.mk
	-@mkdir $(MakeArch) > /dev/null 2>&1
	-@rm -f $@
	-touch $@
	-chmod ug+w $(MakeArch) $@

ArchFixCmd = sed -e '/:/ s+^+$$(MakeArch)/+'
archDepend:	FORCE
ifneq '$(C_SrcFiles)' ''
	$(CC) -MM $(CFLAGS) $(C_SrcFiles)	| $(ArchFixCmd)	>> $(ArchDependFile)
endif
ifneq '$(CXX_SrcFiles)' ''
	$(CXX) -MM $(CXXFLAGS) $(CXX_SrcFiles)	| $(ArchFixCmd)> > $(ArchDependFile)
endif

else

# No file lists wanted

$(ArchDependFile):	FORCE
		@-true

archDepend:	FORCE
		@-true

endif

include $(DependFile)
