#!/bin/sh
# dependfiles.sh
#
# Looks at all files in current dir and groups them into
# categories, and produces makefile sections for each category.
#

MakeDir=${MakeDir-$HOME/etc/make}

C_HdrFiles=
C_SrcFiles=
CXX_SrcFiles=
Tcl_SrcFiles=

for f in `ls`; do
    case "$f" in
    \#*)	;;
    *.h)	C_HdrFiles="$C_HdrFiles $f"	;;
    *.c)	C_SrcFiles="$C_SrcFiles $f"	;;
    *.cc)	CXX_SrcFiles="$CXX_SrcFiles $f"	;;
    *.tcl)	Tcl_SrcFiles="$Tcl_SrcFiles $f" ;;
    esac
done
    
echo -n "Processing .h" 1>&2
$MakeDir/dependsec.sh C_HdrFiles   .h   +            +  $C_HdrFiles
echo -n ", .c" 1>&2
$MakeDir/dependsec.sh C_SrcFiles   .c   C_ObjFiles   .o $C_SrcFiles
echo -n ", .cc" 1>&2
$MakeDir/dependsec.sh CXX_SrcFiles .cc  CXX_ObjFiles .o $CXX_SrcFiles
echo -n ", .tcl" 1>&2
$MakeDir/dependsec.sh Tcl_SrcFiles .tcl +            +  $Tcl_SrcFiles
echo "." 1>&2
