#!/bin/sh
# dependsec.sh SrcName SrcSuffix TgtName TgtSuffix srcfiles ...
# TgtName and TgtSuffix may be '+' to omit processing (for header files)
# This takes nothing from the enviroment.
#

SrcName=$1; shift
SrcSuffix=$1; shift
TgtName=$1; shift
TgtSuffix=$1; shift
SrcFiles=$*

if [ "$SrcFiles" = "" ] ; then
    exit 0
fi

cat <<END_MSG

#
# $SrcName
#
END_MSG
echo -n "$SrcName =	"
echo "$SrcFiles" | fmt -60 \
	| sed -e '2,$ s/^/		/' -e 's/$/ \\/' -e '$ s/ \\//'

if [ $TgtName = '+' ] ; then
    exit 0
fi

ObjFiles=
ArchObjFiles=
for f in $SrcFiles ; do
     objfile=`echo $f | sed -e "s/\$SrcSuffix$/\$TgtSuffix/"`
     archobjfile="\$(MakeArch)"/$objfile
     echo "${archobjfile}: $f"
     ArchObjFiles="$ArchObjFiles $archobjfile"
     echo "${objfile}: ${archobjfile}"
     ObjFiles="$ObjFiles $objfile"
done

echo -n "$TgtName =	"
echo "$ArchObjFiles" | fmt -60 \
	| sed -e '2,$ s/^/		/' -e 's/$/ \\/' -e '$ s/ \\//'

echo -n ".PHONY: 	"
echo "$ObjFiles" | fmt -60 \
	| sed -e '2,$ s/^/		/' -e 's/$/ \\/' -e '$ s/ \\//'
