#!/bin/sh
# dependtmpl.sh
# This script is invoked from depend.mk.  We sed the template file
# based on info we find in the environment.
# We take the following vars from the environment:
#	MakeDir
#	DependFile
#	PackageType
#	Packages, TestPackages
#	UseArchB

MakeDir=${MakeDir-$HOME/etc/make}
DependFile=${DependFile-DependInfo}
DependFileTmpl=${DependFileTmpl-$MakeDir/$DependFile.tmpl}
PackageType=${PackageType-binary}

if [ ! -f OneLineDesc ] ; then
    echo "Put one line description of package here." >> OneLineDesc
fi

if [ ! -f $DependFileTmpl ] ; then
    echo "Template for DependInfo is missing: $DependFileTmpl"
    exit 1
fi

rm -f $DependFile

#case "$PackageType" in
#  hierarchy|other)	ArchsSub='#';	;;
#  *)			ArchsSub="";	;;
#esac
ArchsSub='#'
if [ "$UseArchB" = "1" ] ; then
    ArchsSub=""
fi
#echo "UseArchB=$UseArchB ArchsSub=$ArchsSub"

SubPackagesB=`expr "$Packages" != ""`
TestPackagesB=`expr "$TestPackages" != ""`
AllPackagesB=`expr $SubPackagesB \| $TestPackagesB`
sed \
  -e "s/<Arch>/$ArchsSub/"					\
  -e "s/^#MakeSubPackages$SubPackagesB/MakeSubPackages/"	\
  -e "s/^#MakeTestPackages$TestPackagesB/MakeTestPackages/"	\
  -e "s/^#MakeAllPackages$AllPackagesB/MakeAllPackages/" \
  < $DependFileTmpl > $DependFile
chmod ug+w $DependFile
