#!/bin/sh
#
# findsrcs.sh

# This is not currently part of the makefile system.
# This searches the (unstripped) binary for the .o files used in its
# creation.  It the searches each if the dirs for a cooresponding .c file,
# and outputs the path to stdout.

SELF=$0
BINARY=$1; shift
if [ ! -x "$BINARY" ] ; then
    echo "usage: $SELF binary searchdir ..."
    exit 1
fi
SEARCH=$*
if [ "$SEARCH" = "" ] ; then
    SEARCH=.
fi

CFLAGS=`echo $SEARCH | sed 's/\([^ ][^ ]*\)/-I\1/g'`
#echo
#echo cflags $CFLAGS
#echo

FINDSRCS=`nm $BINARY | sed -n 's/.*[tf] \(.*\)\.o$/\1.c/p' | sort -u`
#echo
#echo findsrcs $FINDSRCS
#echo

CSRCS=
for src in $FINDSRCS ; do
    for x in $SEARCH ; do
	if [ -r $x/$src ] ; then
	    CSRCS="$CSRCS $x/$src"
	    break
	fi
    done
done
#echo
echo csrcs $CSRCS 1>&2
echo 1>&2


HDRS=` ( for src in $CSRCS ; do					\
    /lib/cpp $CFLAGS $src | sed -n 's/^#.*"\(.*\.h\)".*/\1/p' ;	\
done ; ) 2> /dev/null | sort -u | grep -v "/usr/include"`
#echo
echo hdrs $HDRS 1>&2
echo 1>&2

echo $CSRCS $HDRS
exit 0
