#!/bin/sh
#
# Script, using rdist, to create a "clean" copy of one or more packages.
#
# usage: srcdist.sh [files]
#
# Note that we rdist to `hostname` and not to 'localhost', since localhost
# is screwed up on our cluster.

Package=${Package-package}
if [ "$1" = "" ] ; then
    DistFiles=.
else
    DistFiles=$*
fi

echo "Updating dist in `hostname`:/tmp/dist/$Package"

cat - <<EOF | rdist -f -
EP = (
	.*/RCS/.* .*/SCCS/.*
	.*/sun4.* .*/mips.* .*/junk.* .*/#.* .*\.old .*/core
	.*/[a-z0-9_]*test/[a-z0-9_]*test
)
( $DistFiles ) -> ( `hostname` )
	install -R /tmp/dist/$Package ;
	except_pat ( \${EP} );
EOF
