#
# Makefiles for building X fallback resources
#

XResFile :=		res/$(XResName)
XResFallbackFile :=	fallback.c

$(XResFallbackFile): $(XResFile).src
	-@mv -f $(XResFallbackFile) '#'$(XResFallbackFile) > /dev/null 2>&1
	( echo '#include "X11/Intrinsic.h"' ; \
	  $(CPP) -DFALLBACK -DVISUAL_COLOR $(XResFile).src \
	    | sed -e '/^#/ d' -e '/^$$/ d' \
	    | $(MakeDir)/xres2c.sh XPFallbackResColor ; \
	  $(CPP) -DFALLBACK -DVISUAL_BW -DVISUAL_ANY $(XResFile).src \
	    | sed -e '/^#/ d' -e '/^$$/ d' \
	    | $(MakeDir)/xres2c.sh XPFallbackRes ; \
	) > $(XResFallbackFile)

$(XResFile).color: $(XResFile).src
	$(CPP) -DDEBUG -DVISUAL_COLOR -DVISUAL_ANY $(XResFile).src \
	  | sed -e '/^#/ d' -e '/^$$/ d' > $(XResFile).color

$(XResFile).bw: $(XResFile).src
	$(CPP) -DDEBUG -DVISUAL_BW -DVISUAL_ANY $(XResFile).src \
	  | sed -e '/^#/ d' -e '/^$$/ d' > $(XResFile).bw

color:	$(XResFile).color
	-@mv -f res/XPole $(XResFile).prev > /dev/null 2>&1
	ln -s $(XResName).color $(XResFile)

bw:	$(XResFile).bw
	-@mv -f res/XPole $(XResFile).prev > /dev/null 2>&1
	ln -s $(XResName).bw $(XResFile)

resedit:
	-@vi $(XResFile).src
	$(MAKE) $(XResFile).color $(XResFile).bw
