/**
CUSTOMCOPYRIGHT	-- dont force my copyright onto this
NOWRAPKEY -- dont force my header style onto this

This is a modified C version of ACM algorithm 419.  The fortran version
is available from AT&T's netlib in "toms/419".  As far as I know,
this software is in the public domain (not copyrighted). -- kennard
The authors are M.A. Jenkins and J.F. Traub.

Warning: this algorithm fails if the poly consists only of zeros at the 
origin.  I think this is because it first attempts to directly factor
out origin zeros, and then expects there to be at least one remaining zero
left over for it to "find". -- kennard

C     ALGORITHM 419 COLLECTED ALGORITHMS FROM ACM.
C     ALGORITHM APPEARED IN COMM. ACM, VOL. 15, NO. 02,
C     P. 097.


polyfactor.f -- translated by f2c (version of 27 June 1992  14:50:07).
   You must link the resulting object file with the libraries:
	-lF77 -lI77 -lm -lc   (in that order)

**/

#include "topFixup.h"
#include "topStd.h"
#include "eemDflt.h"
#include "eemPoly.h"

/* #include "f2c.h" */
typedef long int integer;
typedef float real;
typedef double doublereal;
typedef TOPLogical logical;
#define abs(x) ((x) >= 0 ? (x) : -(x))
#define dabs(x) (doublereal)abs(x)
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define dmin(a,b) (doublereal)min(a,b)
#define dmax(a,b) (doublereal)max(a,b)

#define TRUE_ (1)
#define FALSE_ (0)

/* Common Block Declarations */

struct {
    doublereal pr[EEM_CPOLY_SIZE], pi[EEM_CPOLY_SIZE],
	hr[EEM_CPOLY_SIZE], hi[EEM_CPOLY_SIZE],
	qpr[EEM_CPOLY_SIZE], qpi[EEM_CPOLY_SIZE],
	qhr[EEM_CPOLY_SIZE], qhi[EEM_CPOLY_SIZE],
	shr[EEM_CPOLY_SIZE], shi[EEM_CPOLY_SIZE],
	sr, si, tr, ti, pvr, pvi, are, mre, eta, infin;
    integer nn;
} global_;

#define global_1 global_

/* Table of constant values */

static integer c__5 = 5;
static integer c__10 = 10;

/* Subroutine */ int cpoly_(doublereal *opr, doublereal *opi, int *degree,
	 doublereal *zeror, doublereal *zeroi, logical *fail)
{
    /* System generated locals */
    integer i__1;
    doublereal d__1, d__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    doublereal base;
    extern doublereal cmod_(doublereal *, doublereal *);
    extern /* Subroutine */ int mcon_(doublereal *, doublereal *, doublereal *
	    , doublereal *);
    logical conv;
    doublereal cosr, sinr;
    integer idnn2, i;
    extern doublereal scale_(integer *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *);
    doublereal zi;
    extern /* Subroutine */ int cdivid_(doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *);
    doublereal zr;
    extern doublereal cauchy_(integer *, doublereal *, doublereal *);
    doublereal xx, yy, smalno;
    extern /* Subroutine */ int noshft_(integer *), fxshft_(integer *, 
	    doublereal *, doublereal *, logical *);
    doublereal bnd, xxx;
    integer cnt1, cnt2;

/* FINDS THE ZEROS OF A COMPLEX POLYNOMIAL. */
/* OPR, OPI  -  DOUBLE PRECISION VECTORS OF REAL AND */
/* IMAGINARY PARTS OF THE COEFFICIENTS IN */
/* ORDER OF DECREASING POWERS. */
/* DEGREE    -  INTEGER DEGREE OF POLYNOMIAL. */
/* ZEROR, ZEROI  -  OUTPUT DOUBLE PRECISION VECTORS OF */
/* REAL AND IMAGINARY PARTS OF THE ZEROS. */
/* FAIL      -  OUTPUT LOGICAL PARAMETER,  TRUE  ONLY IF */
/* LEADING COEFFICIENT IS ZERO OR IF CPOLY */
/* HAS FOUND FEWER THAN DEGREE ZEROS. */
/* THE PROGRAM HAS BEEN WRITTEN TO REDUCE THE CHANCE OF OVERFLOW */
/* OCCURRING. IF IT DOES OCCUR, THERE IS STILL A POSSIBILITY THAT */
/* THE ZEROFINDER WILL WORK PROVIDED THE OVERFLOWED QUANTITY IS */
/* REPLACED BY A LARGE NUMBER. */
/* COMMON AREA */
/* TO CHANGE THE SIZE OF POLYNOMIALS WHICH CAN BE SOLVED, REPLACE */
/* THE DIMENSION OF THE ARRAYS IN THE COMMON AREA. */
/* INITIALIZATION OF CONSTANTS */
    /* Parameter adjustments */
    --zeroi;
    --zeror;
    --opi;
    --opr;

    /* Function Body */
    mcon_(&global_1.eta, &global_1.infin, &smalno, &base);
    global_1.are = global_1.eta;
    global_1.mre = sqrt(2.) * 2. * global_1.eta;
    xx = .70710678;	/* mips cc doesnt like trailing "f" */
    yy = -xx;
    cosr = -.060756474;
    sinr = .99756405;
    *fail = FALSE_;
    global_1.nn = *degree + 1;
/* ALGORITHM FAILS IF THE LEADING COEFFICIENT IS ZERO. */
    if (opr[1] != 0. || opi[1] != 0.) {
	goto L10;
    }
    *fail = TRUE_;
    return 0;
/* REMOVE THE ZEROS AT THE ORIGIN IF ANY. */
L10:
    if (opr[global_1.nn] != 0. || opi[global_1.nn] != 0.) {
	goto L20;
    }
    idnn2 = *degree - global_1.nn + 2;
    zeror[idnn2] = 0.;
    zeroi[idnn2] = 0.;
    --global_1.nn;
    goto L10;
/* MAKE A COPY OF THE COEFFICIENTS. */
L20:
    i__1 = global_1.nn;
    for (i = 1; i <= i__1; ++i) {
	global_1.pr[i - 1] = opr[i];
	global_1.pi[i - 1] = opi[i];
	global_1.shr[i - 1] = cmod_(&global_1.pr[i - 1], &global_1.pi[i - 1]);

/* L30: */
    }
/* SCALE THE POLYNOMIAL. */
    bnd = scale_(&global_1.nn, global_1.shr, &global_1.eta, &global_1.infin, &
	    smalno, &base);
    if (bnd == 1.) {
	goto L40;
    }
    i__1 = global_1.nn;
    for (i = 1; i <= i__1; ++i) {
	global_1.pr[i - 1] = bnd * global_1.pr[i - 1];
	global_1.pi[i - 1] = bnd * global_1.pi[i - 1];
/* L35: */
    }
/* START THE ALGORITHM FOR ONE ZERO . */
L40:
    if (global_1.nn > 2) {
	goto L50;
    }
/* CALCULATE THE FINAL ZERO AND RETURN. */
    d__1 = -global_1.pr[1];
    d__2 = -global_1.pi[1];
    cdivid_(&d__1, &d__2, global_1.pr, global_1.pi, &zeror[*degree], &zeroi[*
	    degree]);
    return 0;
/* CALCULATE BND, A LOWER BOUND ON THE MODULUS OF THE ZEROS. */
L50:
    i__1 = global_1.nn;
    for (i = 1; i <= i__1; ++i) {
	global_1.shr[i - 1] = cmod_(&global_1.pr[i - 1], &global_1.pi[i - 1]);

/* L60: */
    }
    bnd = cauchy_(&global_1.nn, global_1.shr, global_1.shi);
/* OUTER LOOP TO CONTROL 2 MAJOR PASSES WITH DIFFERENT SEQUENCES */
/* OF SHIFTS. */
    for (cnt1 = 1; cnt1 <= 2; ++cnt1) {
/* FIRST STAGE CALCULATION, NO SHIFT. */
	noshft_(&c__5);
/* INNER LOOP TO SELECT A SHIFT. */
	for (cnt2 = 1; cnt2 <= 9; ++cnt2) {
/* SHIFT IS CHOSEN WITH MODULUS BND AND AMPLITUDE ROTATED BY */
/* 94 DEGREES FROM THE PREVIOUS SHIFT */
	    xxx = cosr * xx - sinr * yy;
	    yy = sinr * xx + cosr * yy;
	    xx = xxx;
	    global_1.sr = bnd * xx;
	    global_1.si = bnd * yy;
/* SECOND STAGE CALCULATION, FIXED SHIFT. */
	    i__1 = cnt2 * 10;
	    fxshft_(&i__1, &zr, &zi, &conv);
	    if (! conv) {
		goto L80;
	    }
/* THE SECOND STAGE JUMPS DIRECTLY TO THE THIRD STAGE ITERATION. 
*/
/* IF SUCCESSFUL THE ZERO IS STORED AND THE POLYNOMIAL DEFLATED. 
*/
	    idnn2 = *degree - global_1.nn + 2;
	    zeror[idnn2] = zr;
	    zeroi[idnn2] = zi;
	    --global_1.nn;
	    i__1 = global_1.nn;
	    for (i = 1; i <= i__1; ++i) {
		global_1.pr[i - 1] = global_1.qpr[i - 1];
		global_1.pi[i - 1] = global_1.qpi[i - 1];
/* L70: */
	    }
	    goto L40;
L80:
/* IF THE ITERATION IS UNSUCCESSFUL ANOTHER SHIFT IS CHOSEN. */
/* L90: */
	    ;
	}
/* IF 9 SHIFTS FAIL, THE OUTER LOOP IS REPEATED WITH ANOTHER */
/* SEQUENCE OF SHIFTS. */
/* L100: */
    }
/* THE ZEROFINDER HAS FAILED ON TWO MAJOR PASSES. */
/* RETURN EMPTY HANDED. */
    *fail = TRUE_;
    return 0;
} /* cpoly_ */

/* Subroutine */ int noshft_(integer *l1)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;

    /* Local variables */
    extern doublereal cmod_(doublereal *, doublereal *);
    integer i, j, n;
    doublereal t1, t2;
    integer jj;
    extern /* Subroutine */ int cdivid_(doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *);
    integer nm1;
    doublereal xni;

/* COMPUTES  THE DERIVATIVE  POLYNOMIAL AS THE INITIAL H */
/* POLYNOMIAL AND COMPUTES L1 NO-SHIFT H POLYNOMIALS. */
/* COMMON AREA */
    n = global_1.nn - 1;
    nm1 = n - 1;
    i__1 = n;
    for (i = 1; i <= i__1; ++i) {
	xni = (doublereal) (global_1.nn - i);
	global_1.hr[i - 1] = xni * global_1.pr[i - 1] / (real) n;
	global_1.hi[i - 1] = xni * global_1.pi[i - 1] / (real) n;
/* L10: */
    }
    i__1 = *l1;
    for (jj = 1; jj <= i__1; ++jj) {
	if (cmod_(&global_1.hr[n - 1], &global_1.hi[n - 1]) <= global_1.eta * 
		10. * cmod_(&global_1.pr[n - 1], &global_1.pi[n - 1])) {
	    goto L30;
	}
	d__1 = -global_1.pr[global_1.nn - 1];
	d__2 = -global_1.pi[global_1.nn - 1];
	cdivid_(&d__1, &d__2, &global_1.hr[n - 1], &global_1.hi[n - 1], &
		global_1.tr, &global_1.ti);
	i__2 = nm1;
	for (i = 1; i <= i__2; ++i) {
	    j = global_1.nn - i;
	    t1 = global_1.hr[j - 2];
	    t2 = global_1.hi[j - 2];
	    global_1.hr[j - 1] = global_1.tr * t1 - global_1.ti * t2 + 
		    global_1.pr[j - 1];
	    global_1.hi[j - 1] = global_1.tr * t2 + global_1.ti * t1 + 
		    global_1.pi[j - 1];
/* L20: */
	}
	global_1.hr[0] = global_1.pr[0];
	global_1.hi[0] = global_1.pi[0];
	goto L50;
/* IF THE CONSTANT TERM IS ESSENTIALLY ZERO, SHIFT H COEFFICIENTS. */
L30:
	i__2 = nm1;
	for (i = 1; i <= i__2; ++i) {
	    j = global_1.nn - i;
	    global_1.hr[j - 1] = global_1.hr[j - 2];
	    global_1.hi[j - 1] = global_1.hi[j - 2];
/* L40: */
	}
	global_1.hr[0] = 0.;
	global_1.hi[0] = 0.;
L50:
	;
    }
    return 0;
} /* noshft_ */

/* Subroutine */ int fxshft_(integer *l2, doublereal *zr, doublereal *zi, 
	logical *conv)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;

    /* Local variables */
    extern doublereal cmod_(doublereal *, doublereal *);
    logical pasd, bool, test;
    doublereal svsi, svsr;
    integer i, j, n;
    extern /* Subroutine */ int calct_(logical *), nexth_(logical *), vrshft_(
	    integer *, doublereal *, doublereal *, logical *), polyev_(
	    integer *, doublereal *, doublereal *, doublereal *, doublereal *,
	     doublereal *, doublereal *, doublereal *, doublereal *);
    doublereal oti, otr;

/* COMPUTES L2 FIXED-SHIFT H POLYNOMIALS AND TESTS FOR */
/* CONVERGENCE. */
/* INITIATES A VARIABLE-SHIFT ITERATION AND RETURNS WITH THE */
/* APPROXIMATE ZERO IF SUCCESSFUL. */
/* L2 - LIMIT OF FIXED SHIFT STEPS */
/* ZR,ZI - APPROXIMATE ZERO IF CONV IS .TRUE. */
/* CONV  - LOGICAL INDICATING CONVERGENCE OF STAGE 3 ITERATION */
/* COMMON AREA */
    n = global_1.nn - 1;
/* EVALUATE P AT S. */
    polyev_(&global_1.nn, &global_1.sr, &global_1.si, global_1.pr, 
	    global_1.pi, global_1.qpr, global_1.qpi, &global_1.pvr, &
	    global_1.pvi);
    test = TRUE_;
    pasd = FALSE_;
/* CALCULATE FIRST T = -P(S)/H(S). */
    calct_(&bool);
/* MAIN LOOP FOR ONE SECOND STAGE STEP. */
    i__1 = *l2;
    for (j = 1; j <= i__1; ++j) {
	otr = global_1.tr;
	oti = global_1.ti;
/* COMPUTE NEXT H POLYNOMIAL AND NEW T. */
	nexth_(&bool);
	calct_(&bool);
	*zr = global_1.sr + global_1.tr;
	*zi = global_1.si + global_1.ti;
/* TEST FOR CONVERGENCE UNLESS STAGE 3 HAS FAILED ONCE OR THIS */
/* IS THE LAST H POLYNOMIAL . */
	if (bool || ! test || j == *l2) {
	    goto L50;
	}
	d__1 = global_1.tr - otr;
	d__2 = global_1.ti - oti;
	if (cmod_(&d__1, &d__2) >= cmod_(zr, zi) * .5) {
	    goto L40;
	}
	if (! pasd) {
	    goto L30;
	}
/* THE WEAK CONVERGENCE TEST HAS BEEN PASSED TWICE, START THE */
/* THIRD STAGE ITERATION, AFTER SAVING THE CURRENT H POLYNOMIAL */
/* AND SHIFT. */
	i__2 = n;
	for (i = 1; i <= i__2; ++i) {
	    global_1.shr[i - 1] = global_1.hr[i - 1];
	    global_1.shi[i - 1] = global_1.hi[i - 1];
/* L10: */
	}
	svsr = global_1.sr;
	svsi = global_1.si;
	vrshft_(&c__10, zr, zi, conv);
	if (*conv) {
	    return 0;
	}
/* THE ITERATION FAILED TO CONVERGE. TURN OFF TESTING AND RESTORE */
/* H,S,PV AND T. */
	test = FALSE_;
	i__2 = n;
	for (i = 1; i <= i__2; ++i) {
	    global_1.hr[i - 1] = global_1.shr[i - 1];
	    global_1.hi[i - 1] = global_1.shi[i - 1];
/* L20: */
	}
	global_1.sr = svsr;
	global_1.si = svsi;
	polyev_(&global_1.nn, &global_1.sr, &global_1.si, global_1.pr, 
		global_1.pi, global_1.qpr, global_1.qpi, &global_1.pvr, &
		global_1.pvi);
	calct_(&bool);
	goto L50;
L30:
	pasd = TRUE_;
	goto L50;
L40:
	pasd = FALSE_;
L50:
	;
    }
/* ATTEMPT AN ITERATION WITH FINAL H POLYNOMIAL FROM SECOND STAGE. */
    vrshft_(&c__10, zr, zi, conv);
    return 0;
} /* fxshft_ */

/* Subroutine */ int vrshft_(integer *l3, doublereal *zr, doublereal *zi, 
	logical *conv)
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    extern doublereal cmod_(doublereal *, doublereal *);
    logical bool, b;
    integer i, j;
    extern /* Subroutine */ int calct_(logical *);
    extern doublereal errev_(integer *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *);
    extern /* Subroutine */ int nexth_(logical *);
    doublereal r1, r2, mp, ms, tp, relstp = 0.0;
    extern /* Subroutine */ int polyev_(integer *, doublereal *, doublereal *,
	     doublereal *, doublereal *, doublereal *, doublereal *, 
	    doublereal *, doublereal *);
    doublereal omp = global_1.infin;

/* CARRIES OUT THE THIRD STAGE ITERATION. */
/* L3 - LIMIT OF STEPS IN STAGE 3. */
/* ZR,ZI   - ON ENTRY CONTAINS THE INITIAL ITERATE, IF THE */
/* ITERATION CONVERGES IT CONTAINS THE FINAL ITERATE */
/* ON EXIT. */
/* CONV    -  .TRUE. IF ITERATION CONVERGES */
/* COMMON AREA */
    *conv = FALSE_;
    b = FALSE_;
    global_1.sr = *zr;
    global_1.si = *zi;
/* MAIN LOOP FOR STAGE THREE */
    i__1 = *l3;
    for (i = 1; i <= i__1; ++i) {
/* EVALUATE P AT S AND TEST FOR CONVERGENCE. */
	polyev_(&global_1.nn, &global_1.sr, &global_1.si, global_1.pr, 
		global_1.pi, global_1.qpr, global_1.qpi, &global_1.pvr, &
		global_1.pvi);
	mp = cmod_(&global_1.pvr, &global_1.pvi);
	ms = cmod_(&global_1.sr, &global_1.si);
	if (mp > errev_(&global_1.nn, global_1.qpr, global_1.qpi, &ms, &mp, &
		global_1.are, &global_1.mre) * 20.) {
	    goto L10;
	}
/* POLYNOMIAL VALUE IS SMALLER IN VALUE THAN A BOUND ON THE ERROR */
/* IN EVALUATING P, TERMINATE THE ITERATION. */
	*conv = TRUE_;
	*zr = global_1.sr;
	*zi = global_1.si;
	return 0;
L10:
	if (i == 1) {
	    goto L40;
	}
	if (b || mp < omp || relstp >= .05) {
	    goto L30;
	}
/* ITERATION HAS STALLED. PROBABLY A CLUSTER OF ZEROS. DO 5 FIXED */
/* SHIFT STEPS INTO THE CLUSTER TO FORCE ONE ZERO TO DOMINATE. */
	tp = relstp;
	b = TRUE_;
	if (relstp < global_1.eta) {
	    tp = global_1.eta;
	}
	r1 = sqrt(tp);
	r2 = global_1.sr * (r1 + 1.) - global_1.si * r1;
	global_1.si = global_1.sr * r1 + global_1.si * (r1 + 1.);
	global_1.sr = r2;
	polyev_(&global_1.nn, &global_1.sr, &global_1.si, global_1.pr, 
		global_1.pi, global_1.qpr, global_1.qpi, &global_1.pvr, &
		global_1.pvi);
	for (j = 1; j <= 5; ++j) {
	    calct_(&bool);
	    nexth_(&bool);
/* L20: */
	}
	omp = global_1.infin;
	goto L50;
/* EXIT IF POLYNOMIAL VALUE INCREASES SIGNIFICANTLY. */
L30:
	if (mp * .1 > omp) {
	    return 0;
	}
L40:
	omp = mp;
/* CALCULATE NEXT ITERATE. */
L50:
	calct_(&bool);
	nexth_(&bool);
	calct_(&bool);
	if (bool) {
	    goto L60;
	}
	relstp = cmod_(&global_1.tr, &global_1.ti) / cmod_(&global_1.sr, &
		global_1.si);
	global_1.sr += global_1.tr;
	global_1.si += global_1.ti;
L60:
	;
    }
    return 0;
} /* vrshft_ */

/* Subroutine */ int calct_(logical *bool)
{
    /* System generated locals */
    doublereal d__1, d__2;

    /* Local variables */
    extern doublereal cmod_(doublereal *, doublereal *);
    integer n;
    extern /* Subroutine */ int cdivid_(doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *), polyev_(
	    integer *, doublereal *, doublereal *, doublereal *, doublereal *,
	     doublereal *, doublereal *, doublereal *, doublereal *);
    doublereal hvi, hvr;

/* COMPUTES  T = -P(S)/H(S). */
/* BOOL   - LOGICAL, SET TRUE IF H(S) IS ESSENTIALLY ZERO. */
/* COMMON AREA */
    n = global_1.nn - 1;
/* EVALUATE H(S). */
    polyev_(&n, &global_1.sr, &global_1.si, global_1.hr, global_1.hi, 
	    global_1.qhr, global_1.qhi, &hvr, &hvi);
    *bool = cmod_(&hvr, &hvi) <= global_1.are * 10. * cmod_(&global_1.hr[n - 
	    1], &global_1.hi[n - 1]);
    if (*bool) {
	goto L10;
    }
    d__1 = -global_1.pvr;
    d__2 = -global_1.pvi;
    cdivid_(&d__1, &d__2, &hvr, &hvi, &global_1.tr, &global_1.ti);
    return 0;
L10:
    global_1.tr = 0.;
    global_1.ti = 0.;
    return 0;
} /* calct_ */

/* Subroutine */ int nexth_(logical *bool)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    integer j, n;
    doublereal t1, t2;
    integer nm1;

/* CALCULATES THE NEXT SHIFTED H POLYNOMIAL. */
/* BOOL   -  LOGICAL, IF .TRUE. H(S) IS ESSENTIALLY ZERO */
/* COMMON AREA */
    n = global_1.nn - 1;
    nm1 = n - 1;
    if (*bool) {
	goto L20;
    }
    i__1 = n;
    for (j = 2; j <= i__1; ++j) {
	t1 = global_1.qhr[j - 2];
	t2 = global_1.qhi[j - 2];
	global_1.hr[j - 1] = global_1.tr * t1 - global_1.ti * t2 + 
		global_1.qpr[j - 1];
	global_1.hi[j - 1] = global_1.tr * t2 + global_1.ti * t1 + 
		global_1.qpi[j - 1];
/* L10: */
    }
    global_1.hr[0] = global_1.qpr[0];
    global_1.hi[0] = global_1.qpi[0];
    return 0;
/* IF H(S) IS ZERO REPLACE H WITH QH. */
L20:
    i__1 = n;
    for (j = 2; j <= i__1; ++j) {
	global_1.hr[j - 1] = global_1.qhr[j - 2];
	global_1.hi[j - 1] = global_1.qhi[j - 2];
/* L30: */
    }
    global_1.hr[0] = 0.;
    global_1.hi[0] = 0.;
    return 0;
} /* nexth_ */

/* Subroutine */ int polyev_(integer *nn, doublereal *sr, doublereal *si, 
	doublereal *pr, doublereal *pi, doublereal *qr, doublereal *qi, 
	doublereal *pvr, doublereal *pvi)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    integer i;
    doublereal t;

/* EVALUATES A POLYNOMIAL  P  AT  S  BY THE HORNER RECURRENCE */
/* PLACING THE PARTIAL SUMS IN Q AND THE COMPUTED VALUE IN PV. */
    /* Parameter adjustments */
    --qi;
    --qr;
    --pi;
    --pr;

    /* Function Body */
    qr[1] = pr[1];
    qi[1] = pi[1];
    *pvr = qr[1];
    *pvi = qi[1];
    i__1 = *nn;
    for (i = 2; i <= i__1; ++i) {
	t = *pvr * *sr - *pvi * *si + pr[i];
	*pvi = *pvr * *si + *pvi * *sr + pi[i];
	*pvr = t;
	qr[i] = *pvr;
	qi[i] = *pvi;
/* L10: */
    }
    return 0;
} /* polyev_ */

doublereal errev_(integer *nn, doublereal *qr, doublereal *qi, doublereal *ms,
	 doublereal *mp, doublereal *are, doublereal *mre)
{
    /* System generated locals */
    integer i__1;
    doublereal ret_val;

    /* Local variables */
    extern doublereal cmod_(doublereal *, doublereal *);
    doublereal e;
    integer i;

/* BOUNDS THE ERROR IN EVALUATING THE POLYNOMIAL BY THE HORNER */
/* RECURRENCE. */
/* QR,QI - THE PARTIAL SUMS */
/* MS    -MODULUS OF THE POINT */
/* MP    -MODULUS OF POLYNOMIAL VALUE */
/* ARE, MRE -ERROR BOUNDS ON COMPLEX ADDITION AND MULTIPLICATION */
    /* Parameter adjustments */
    --qi;
    --qr;

    /* Function Body */
    e = cmod_(&qr[1], &qi[1]) * *mre / (*are + *mre);
    i__1 = *nn;
    for (i = 1; i <= i__1; ++i) {
	e = e * *ms + cmod_(&qr[i], &qi[i]);
/* L10: */
    }
    ret_val = e * (*are + *mre) - *mp * *mre;
    return ret_val;
} /* errev_ */

doublereal cauchy_(integer *nn, doublereal *pt, doublereal *q)
{
    /* System generated locals */
    integer i__1;
    doublereal ret_val, d__1;

    /* Builtin functions */
    double log(doublereal), exp(doublereal);

    /* Local variables */
    doublereal f;
    integer i, n;
    doublereal x, df, dx, xm;

/* CAUCHY COMPUTES A LOWER BOUND ON THE MODULI OF THE ZEROS OF A */
/* POLYNOMIAL - PT IS THE MODULUS OF THE COEFFICIENTS. */
    /* Parameter adjustments */
    --q;
    --pt;

    /* Function Body */
    pt[*nn] = -pt[*nn];
/* COMPUTE UPPER ESTIMATE OF BOUND. */
    n = *nn - 1;
    x = exp((log(-pt[*nn]) - log(pt[1])) / (real) n);
    if (pt[n] == 0.) {
	goto L20;
    }
/* IF NEWTON STEP AT THE ORIGIN IS BETTER, USE IT. */
    xm = -pt[*nn] / pt[n];
    if (xm < x) {
	x = xm;
    }
/* CHOP THE INTERVAL (0,X) UNITL F LE 0. */
L20:
    xm = x * .1;
    f = pt[1];
    i__1 = *nn;
    for (i = 2; i <= i__1; ++i) {
	f = f * xm + pt[i];
/* L30: */
    }
    if (f <= 0.) {
	goto L40;
    }
    x = xm;
    goto L20;
L40:
    dx = x;
/* DO NEWTON ITERATION UNTIL X CONVERGES TO TWO DECIMAL PLACES. */
L50:
    if ((d__1 = dx / x, abs(d__1)) <= .005) {
	goto L70;
    }
    q[1] = pt[1];
    i__1 = *nn;
    for (i = 2; i <= i__1; ++i) {
	q[i] = q[i - 1] * x + pt[i];
/* L60: */
    }
    f = q[*nn];
    df = q[1];
    i__1 = n;
    for (i = 2; i <= i__1; ++i) {
	df = df * x + q[i];
/* L65: */
    }
    dx = f / df;
    x -= dx;
    goto L50;
L70:
    ret_val = x;
    return ret_val;
} /* cauchy_ */

doublereal scale_(integer *nn, doublereal *pt, doublereal *eta, doublereal *
	infin, doublereal *smalno, doublereal *base)
{
    /* System generated locals */
    integer i__1;
    doublereal ret_val;

    /* Builtin functions */
    double sqrt(doublereal), log(doublereal), pow_di(doublereal *, integer *);


    /* Local variables */
    integer i, l;
    doublereal x, hi, sc, lo, min_, max_;

/* RETURNS A SCALE FACTOR TO MULTIPLY THE COEFFICIENTS OF THE */
/* POLYNOMIAL. THE SCALING IS DONE TO AVOID OVERFLOW AND TO AVOID */
/* UNDETECTED UNDERFLOW INTERFERING WITH THE CONVERGENCE */
/* CRITERION.  THE FACTOR IS A POWER OF THE BASE. */
/* PT - MODULUS OF COEFFICIENTS OF P */
/* ETA,INFIN,SMALNO,BASE - CONSTANTS DESCRIBING THE */
/* FLOATING POINT ARITHMETIC. */
/* FIND LARGEST AND SMALLEST MODULI OF COEFFICIENTS. */
    /* Parameter adjustments */
    --pt;

    /* Function Body */
    hi = sqrt(*infin);
    lo = *smalno / *eta;
    max_ = 0.;
    min_ = *infin;
    i__1 = *nn;
    for (i = 1; i <= i__1; ++i) {
	x = pt[i];
	if (x > max_) {
	    max_ = x;
	}
	if (x != 0. && x < min_) {
	    min_ = x;
	}
/* L10: */
    }
/* SCALE ONLY IF THERE ARE VERY LARGE OR VERY SMALL COMPONENTS. */
    ret_val = 1.;
    if (min_ >= lo && max_ <= hi) {
	return ret_val;
    }
    x = lo / min_;
    if (x > 1.) {
	goto L20;
    }
    sc = 1. / (sqrt(max_) * sqrt(min_));
    goto L30;
L20:
    sc = x;
    if (*infin / sc > max_) {
	sc = 1.;
    }
L30:
    l = (integer) (log(sc) / log(*base) + .5);
    ret_val = pow_di(base, &l);
    return ret_val;
} /* scale_ */

/* Subroutine */ int cdivid_(doublereal *ar, doublereal *ai, doublereal *br, 
	doublereal *bi, doublereal *cr, doublereal *ci)
{
    extern /* Subroutine */ int mcon_(doublereal *, doublereal *, doublereal *
	    , doublereal *);
    doublereal d, r, t, infin;

/* COMPLEX DIVISION C = A/B, AVOIDING OVERFLOW. */
    if (*br != 0. || *bi != 0.) {
	goto L10;
    }
/* DIVISION BY ZERO, C = INFINITY. */
    mcon_(&t, &infin, &t, &t);
    *cr = infin;
    *ci = infin;
    return 0;
L10:
    if (abs(*br) >= abs(*bi)) {
	goto L20;
    }
    r = *br / *bi;
    d = *bi + r * *br;
    *cr = (*ar * r + *ai) / d;
    *ci = (*ai * r - *ar) / d;
    return 0;
L20:
    r = *bi / *br;
    d = *br + r * *bi;
    *cr = (*ar + *ai * r) / d;
    *ci = (*ai - *ar * r) / d;
    return 0;
} /* cdivid_ */

doublereal cmod_(doublereal *r, doublereal *i)
{
    /* System generated locals */
    doublereal ret_val, d__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    doublereal ai, ar;

/* MODULUS OF A COMPLEX NUMBER AVOIDING OVERFLOW. */
    ar = abs(*r);
    ai = abs(*i);
    if (ar >= ai) {
	goto L10;
    }
/* Computing 2nd power */
    d__1 = ar / ai;
    ret_val = ai * sqrt(d__1 * d__1 + 1.);
    return ret_val;
L10:
    if (ar <= ai) {
	goto L20;
    }
/* Computing 2nd power */
    d__1 = ai / ar;
    ret_val = ar * sqrt(d__1 * d__1 + 1.);
    return ret_val;
L20:
    ret_val = ar * sqrt(2.);
    return ret_val;
} /* cmod_ */

/* Subroutine */ int mcon_(doublereal *eta, doublereal *infiny, doublereal *
	smalno, doublereal *base)
{
    /* Builtin functions */
    double pow_di(doublereal *, integer *);

#ifdef notdef
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;
    /* Local variables */
    integer m, n, t;
#endif

/* MCON PROVIDES MACHINE CONSTANTS USED IN VARIOUS PARTS OF THE */
/* PROGRAM. THE USER MAY EITHER SET THEM DIRECTLY OR USE THE */
/* STATEMENTS BELOW TO COMPUTE THEM. THE MEANING OF THE FOUR */
/* CONSTANTS ARE - */
/* ETA       THE MAXIMUM RELATIVE REPRESENTATION ERROR */
/* WHICH CAN BE DESCRIBED AS THE SMALLEST POSITIVE */
/* FLOATING-POINT NUMBER SUCH THAT 1.0D0 + ETA IS */
/* GREATER THAN 1.0D0. */
/* INFINY    THE LARGEST FLOATING-POINT NUMBER */
/* SMALNO    THE SMALLEST POSITIVE FLOATING-POINT NUMBER */
/* BASE      THE BASE OF THE FLOATING-POINT NUMBER SYSTEM USED */
/* LET T BE THE NUMBER OF BASE-DIGITS IN EACH FLOATING-POINT */
/* NUMBER(DOUBLE PRECISION). THEN ETA IS EITHER .5*B**(1-T) */
/* OR B**(1-T) DEPENDING ON WHETHER ROUNDING OR TRUNCATION */
/* IS USED. */
/* LET M BE THE LARGEST EXPONENT AND N THE SMALLEST EXPONENT */
/* IN THE NUMBER SYSTEM. THEN INFINY IS (1-BASE**(-T))*BASE**M */
/* AND SMALNO IS BASE**N. */
/* THE VALUES FOR BASE,T,M,N BELOW CORRESPOND TO THE IBM/360. */
    *base = 16.;
#ifdef notdef
    t = 14;
    m = 63;
    n = -65;
    i__1 = 1 - t;
    *eta = pow_di(base, &i__1);
    i__1 = -t;
    i__2 = m - 1;
    *infiny = *base * (1. - pow_di(base, &i__1)) * pow_di(base, &i__2);
    i__1 = n + 3;
/* Computing 3rd power */
    d__1 = *base, d__2 = d__1;
    *smalno = pow_di(base, &i__1) / (d__2 * (d__1 * d__1));
#else
    eemParamsInit();
    *base = 2.;
    *eta = EEMParams.Ulp;
    *infiny = 1.797693134862315708e+308;
    *smalno = EEMParams.Smallno;
    return 0;
#endif
} /* mcon_ */

