/* 
    Author: Mei-Tjng Huang & Kennard White

    Copyright (c) 1990-93 The Regents of the University of California.
    All rights reserved.  See the file "./copyright.h" for full copyright
    notice, limitation of liability, and disclaimer of warranty provisions.
#include "copyright.h"				COPYRIGHTENDKEY
*/
#if !defined(lint) && !defined(SABER)
static char rcsid[] = "$Header: /vol/cooley/cooley1/kennard/src/eem/RCS/jefTcl.c,v 1.16 93/08/27 14:29:36 kennard Exp $";
#endif


#include "topFixup.h"
#include <stdio.h>
#include <math.h>
#include <tcl.h>

#include "topStd.h"
#include "topMem.h"
#include "topVec.h"
#include "topTcl.h"

#include "eemDflt.h"
#include "eemCplx.h"
#include "eemSilar.h"
#include "eemJef.h"

static int 
_eemEllipFilterCmd( ClientData cld, Tcl_Interp *ip, int aC, char **aV) {
    int			N;
    double		m, delta, w_pass;
    EEMSilarGrp		silarGrp;

    if ( aC != 5 ) {
	topTclRetFmt( ip, "usage: %s N w_pass m delta", aV[0]);
	return TCL_ERROR;
    }
    if ( Tcl_GetInt( ip, aV[1], &N) != TCL_OK )
	return TCL_ERROR;
    if ( Tcl_GetDouble( ip, aV[2], &w_pass) != TCL_OK )
	return TCL_ERROR;
    if ( Tcl_GetDouble( ip, aV[3], &m) != TCL_OK )
	return TCL_ERROR;
    if ( Tcl_GetDouble( ip, aV[4], &delta) != TCL_OK )
	return TCL_ERROR;

    eemSilarGrpConstructor( &silarGrp);
    if ( eemEllipFilter( &silarGrp, N, w_pass, m, delta) < 0 ) {
	Tcl_AppendResult(ip,aV[0],": command failed",NULL);
	return TCL_ERROR;
    }
    eemSilarGrpFmtTcl( ip, &silarGrp, TOP_FALSE);
    eemSilarGrpDestructor( &silarGrp);
    return TCL_OK;
}

int
eemEllipRegisterCmds( Tcl_Interp *ip) {
    Tcl_CreateCommand( ip, "ellip", _eemEllipFilterCmd, NULL, NULL);
    return TCL_OK;
}
