#include "topFixup.h"
#include <stdio.h>
#include <math.h>

#include "topStd.h"
#include "topMem.h"

#include "eemDflt.h"
#include "eemCplx.h"
#include "eemSilar.h"
#include "eemPoly.h"
#include "eemPfe.h"
#include "eemLoci.h"

extern char _EemRootSubPackage[];
#define SPKG _EemRootSubPackage

int
main( int argc, char **argv) {
    EEMLociGrp LociGrp, LG, *pLG, *pLGrp;
    EEMBox Box;
    EEMSilarGrp SGrp, *pSG, Sing, *pSing, Search, *pSearch;
    EEMPolyCplxRat Rat, *pRat;
    double k = 0.0;
    int i;

    pLG = MEM_ALLOC(EEMLociGrp);
    pSG = MEM_ALLOC(EEMSilarGrp);
    pSing = MEM_ALLOC(EEMSilarGrp);
    pSearch = MEM_ALLOC(EEMSilarGrp);
    pRat = MEM_ALLOC(EEMPolyCplxRat);

    topMsgPkgAdd(SPKG);

    eemLociGrpConstructor( &LociGrp, NULL);
    eemLociGrpConstructor( &LG, &LociGrp);
    eemSilarGrpConstructor( &SGrp);
    eemSilarGrpConstructor( &Search);

    pLGrp = &LociGrp;
    pLG = &LG;
    pSG = &SGrp;
    pSing = &Sing;
    pRat = &Rat;
    pSearch = &Search;
    eemSilarGrpSetNum( &Search, 0);
    eemSilarGrpSetNum( pSG, 3);
/**
    Case of no singular points
    i=0;
    EEM_SILAR_Get(pSG, i).loc.r = -3.0;
    EEM_SILAR_Get(pSG, i).loc.i = 0.0;
    EEM_SILAR_Get(pSG, i).power = -1;
    i=1;
    EEM_SILAR_Get(pSG, i).loc.r = -1;
    EEM_SILAR_Get(pSG, i).loc.i = 4.2426407; 
    EEM_SILAR_Get(pSG, i).power = -2;
**/
    i=0;
    EEM_SILAR_Get(pSG, i).loc.r = -1.0;
    EEM_SILAR_Get(pSG, i).loc.i = 0.0; 
    EEM_SILAR_Get(pSG, i).power = -2;
    i=1;
    EEM_SILAR_Get(pSG, i).loc.r = -1;
    EEM_SILAR_Get(pSG, i).loc.i = 4.2426407;
    EEM_SILAR_Get(pSG, i).power = -1;
    i=2;
    EEM_SILAR_Get(pSG, i).loc.r = -1;
    EEM_SILAR_Get(pSG, i).loc.i = -4.2426407;
    EEM_SILAR_Get(pSG, i).power = -1;
/**
    eemSilarGrpSetNum( pSG, 5);
    i=0;
    EEM_SILAR_Get(pSG, i).loc.r = -1.5;
    EEM_SILAR_Get(pSG, i).loc.i = 0.0;
    EEM_SILAR_Get(pSG, i).power = 1;
    i=1;
    EEM_SILAR_Get(pSG, i).loc.r = -5.5;
    EEM_SILAR_Get(pSG, i).loc.i = 0.0; 
    EEM_SILAR_Get(pSG, i).power = 1;
    i=2;
    EEM_SILAR_Get(pSG, i).loc.r = 0.0;
    EEM_SILAR_Get(pSG, i).loc.i = 0.0;
    EEM_SILAR_Get(pSG, i).power = -1;
    i=3;
    EEM_SILAR_Get(pSG, i).loc.r = -1.0;
    EEM_SILAR_Get(pSG, i).loc.i = 0.0;
    EEM_SILAR_Get(pSG, i).power = -1;
    i=4;
    EEM_SILAR_Get(pSG, i).loc.r = -5.0;
    EEM_SILAR_Get(pSG, i).loc.i = 0.0;
    EEM_SILAR_Get(pSG, i).power = -1;
**/
    Box.lo.x = -8.0;
    Box.lo.y = -5.0;
    Box.hi.x =  1.0;
    Box.hi.y = 5.0;
    Box.delta.x = .1;
    Box.delta.y = .1;

    printf("\nBox:\t lo:(%g,%g), \t hi:(%g,%g), \t delta:(%g,%g)\n",Box.lo.x, Box.lo.y, Box.hi.x, Box.hi.y, Box.delta.x, Box.delta.y);

    eemSilarGrpPrint(pSG, "\n");
    eemRootLociMaster(pLGrp, &Box, pSG, k,TOP_TRUE); 
    eemLocusPtAtK(pLGrp, 20.0, &Search);
    Box.lo.x = -1.5;
    Box.lo.y = -3.5;
    Box.hi.x =  0.0;
    Box.hi.y = 3.5;
    Box.delta.x = .01;
    Box.delta.y = .01;
/**
    eemRootLociKRange(pLGrp, pLG, &Box, -30.0, -32.0);
**/
    eemRootLociZoomInK(pLGrp, pLG, &Box, 30., 70.);
    eemLociGrpDestructor( &LociGrp);
    eemLociGrpDestructor( &LG);
    eemSilarGrpDestructor( &SGrp);
    eemSilarGrpDestructor( &Search);

    exit(0);
}
