#if !defined(_TOPMEM_H_)
#define _TOPMEM_H_ 1
/* 
    RCS: $Header: /vol/cooley/cooley1/kennard/src/top/RCS/topMem.h,v 1.2 93/08/27 14:28:46 kennard Exp $
    Author: Kennard White

    Copyright (c) 1990-93 The Regents of the University of California.
    All rights reserved.  See the file "./copyright.h" for full copyright
    notice, limitation of liability, and disclaimer of warranty provisions.
#include "copyright.h"				COPYRIGHTENDKEY
*/


/*****************************************************************************
 *
 *		Types visible to the application
 *
 *****************************************************************************/


typedef struct _MEMPoolSeg	MEMPoolSeg,	*MEMPoolSegHandle;
typedef struct _MEMPool		MEMPool,	*MEMPoolHandle;
typedef struct _MEMPoolFree	MEMPoolFree,	*MEMPoolFreeHandle;
typedef struct _MEMStack	MEMStack,	*MEMStackHandle;
typedef struct _MEMSuperHeap	MEMSuperHeap,	*MEMSuperHeapHandle;
typedef struct _MEMHeap		MEMHeap,	*MEMHeapHandle;
typedef struct _MEMCore		MEMCore,	*MEMCoreHandle;

typedef void (MEMMallocFailFunc) ARGS((unsigned alloc_size, char *where));

/*****************************************************************************
 *
 *		Type-casting macros
 *
 *****************************************************************************/

#define MEM_ALLOC(t)		( (t*)memMalloc(sizeof(t)) )
#define MEM_ALLOC_VEC(t,n)	( (t*)memCalloc(n,sizeof(t)) )
#define MEM_REALLOC_VEC(p,t,n)	( (t*)realloc((char*)p, sizeof(t)*(n)) )
#define MEM_FREE(x)		( (x) == 0 ? 0 : (memFree(x),0) )

#define MEM_CLEAR(p)		( memset((char*)p, 0, sizeof(*p)),0 )

/*****************************************************************************
 *
 *		Exports
 *
 *****************************************************************************/

/* memCore.c */
extern TOPStatus	memInitialize(/* acp, avp */);

/* memFail.c */
extern MEMMallocFailFunc* memSetMallocFailFunc ARGS((MEMMallocFailFunc *func));
extern void		memMallocFail ARGS((unsigned allocSize, char *where));

/* memMalloc.c */
extern TOPMallocPtr	memMalloc(/* size */);
extern TOPMallocPtr	memCalloc(/* nelem, elsize */);
extern TOPMallocPtr	memRealloc(/* ptr, size */);
extern void		memFree(/* ptr */);
extern char*		memStrSave ARGS((char *s));
extern char*		memStrSaveVa ARGS_VA((char *fmt, va_list args));
extern char*		memStrSaveFmt ARGS((char *fmt, ...));


/* memPool.c */
extern void		memPoolConstructor ARGS((MEMPool *pPool, int initialPoolSize));
extern void		memPoolDestructor ARGS((MEMPool *pPool));
extern TOPPtr		memPoolObAlloc ARGS((MEMPool *pPool, int allocSize));
extern TOPPtr		memPoolObTryAlloc ARGS((MEMPool *pPool, int allocSize));
extern TOPLogical	memPoolObValidB ARGS((MEMPool *pPool, TOPPtr pOb, int *pOfs));


/* memHeap.c */
extern MEMSuperHeap*	memSuperHeapCreate ARGS((char *name, int objectSize));
extern void		memSuperHeapDestroy ARGS((MEMSuperHeap *pSuper));
extern TOPPtr		memSuperHeapObAlloc ARGS((MEMSuperHeap *pSuper));
extern TOPStatus	memSuperHeapObFree ARGS((MEMSuperHeap *pSuper,
			  TOPPtr pOb));
extern void		memSuperHeapConstructor ARGS((MEMSuperHeap *pSuper,
			  char *name, int objectSize));
extern void		memSuperHeapDestructor ARGS((MEMSuperHeap *pSuper));
extern TOPLogical	memSuperHeapObFreeB ARGS((MEMSuperHeap *pSuper, 
			  TOPPtr pOb));
extern TOPLogical	memSuperHeapObValidB ARGS((MEMSuperHeap *pSuper, 
			  TOPPtr pOb));

extern MEMHeap*		memHeapCreate ARGS((char *name, MEMSuperHeap *pSuper));
extern TOPStatus	memHeapBuild(/* name, objectSize, ppSuper, ppHeap */);
extern void		memHeapDestroy ARGS((MEMHeap *pHeap));
extern TOPPtr		memHeapObAlloc ARGS((MEMHeap *pHeap));
extern TOPStatus	memHeapObFree ARGS((MEMHeap *pHeap, TOPPtr pOb));
extern void		memHeapConstructor ARGS((MEMHeap *pHeap, char *name, MEMSuperHeap *pSuper));
extern void		memHeapDestructor ARGS((MEMHeap *pHeap));
extern char*		memHeapGetName ARGS((MEMHeap *pHeap));


/* memPublic.c */
extern MEMHeap*		memPublicHeapCreate ARGS((char *name, int objectSize));

/* memStack.c */
extern MEMStack*	memStackCreate ARGS((char *name));
extern void		memStackDestroy ARGS((MEMStack *pStack));
extern TOPPtr		memStackObAlloc ARGS((MEMStack *pStack, int size));
extern void		memStackConstructor ARGS((MEMStack *pStack, char *name));
extern void		memStackDestructor ARGS((MEMStack *pStack));
extern TOPLogical	memStackObValidB ARGS((MEMStack *pStack, TOPPtr pOb));

/* memTcl.c */
extern int		memRegisterCmds ARGS_TCL((Tcl_Interp *ip));

#endif /* _TOPMEM_H_ */
