#if !defined(_FILTER_H_)
#define _FILTER_H_ 1
/**
    filter.h

    Author: Kennard White

    90/10/13 KDW: Created as xpole.h
    91/Mar/29 KDW: Extracted portions into filter.h

    RCS: $Header: /vol/cooley/cooley1/kennard/src/xpole/RCS/filter.h,v 1.5 93/08/27 14:28:04 kennard Exp $

    Copyright (c) 1990-93 The Regents of the University of California.
    All rights reserved.  See the file "./copyright.h" for full copyright
    notice, limitation of liability, and disclaimer of warranty provisions.
#include "copyright.h"				COPYRIGHTENDKEY
**/

typedef struct _XPCplxSeqSnapPt XPCplxSeqSnapPt;
typedef struct _XPCplxSeqSnap XPCplxSeqSnap;
typedef struct _XPCplxSeqView XPCplxSeqView;

typedef struct _EEMSilar XPSilar;
typedef struct _XPSilarSnap XPSilarSnap;
typedef struct _XPSilarView XPSilarView;

typedef XPSilarView XPSilarDB;

typedef struct _XPFilter XPFilter;


/**
    The mathamatical transform domain where the filter lives:
    either LaPlace transform (s), or Z-transform(z).
**/
typedef char XPXformDomain;
#define XP_XFDOM_UNKNOWN	'?'
#define XP_XFDOM_S		's'
#define XP_XFDOM_Z		'z'


#if !defined(_XPVIEW_H_) && __TOP_AUTOINCLUDE__
#include "xpView.h"
#endif

#define XP_FLTR_MAX_NAME_LEN	100


struct _XPFilter {
    XPLabel		Lbl;
    int			Flags;
    int			XfDomain;	/* e.g. S or Z */
    char*		Name;		/* e.g. H1 */
    char*		XfName;		/* e.g. H1(s) */
    int			ChangeMask;
    char*		Desc;		/* dynamic, unformated text desc */
    TOPPtrVector	Views;
};

/*
 * from fltr.c
 */
extern XPFilter*	xpFltrCreate( Tcl_Interp *ip,
			  char *name, XPXformDomain xd);
extern void		xpFltrDestroy( Tcl_Interp *ip, XPFilter *pFltr);

extern XPFilter*	xpFltrFindCur();
extern void		xpFltrSetCur(XPFilter *pFltr);

extern XPFilter*	xpFltrFindByName( char *name, XPXformDomain d);
extern TOPLogical	xpFltrFindBySpec( char *spec, 
			  XPFilter **ppFltr, TOPLogical hintB);
extern char*		xpGenFilterName();
extern void		xpFilterUpdate( XPFilter *pFltr);

extern XPXformDomain	xpDomainNameToType(char name);
extern char		xpDomainTypeToName(XPXformDomain t);
extern TOPLogical	xpFltrParseName( char *name, XPXformDomain defDomain,
  			  char **nameEnd, char *base, XPXformDomain *d);

extern void		xpDestroy();

extern void		xpFltrListChange();
extern void		xpFltrAddView( XPFilter *pFltr, XPView *pView);

/*
 * from poleTcl.c
 */
extern void		xpSetDefXfDomain( XPXformDomain dom);
extern XPXformDomain	xpGetDefXfDomain();


/*
 * from fltrTcl.c
 */
extern int	_xpFltrCmdsPrs ARGS_TCL((XPFilter *pFltr, Tcl_Interp *ip,
		  char *cmd, int aC, char **aV));
extern int		_xpFltrCmds( ClientData cld, Tcl_Interp *ip,
			  int aC, char **aV);
extern int		_xpFilterCmd( ClientData cld, Tcl_Interp *ip,
			  int aC, char **aV);
extern int		_xpFltrDotCmd( ClientData cld, Tcl_Interp *ip,
			  int aC, char **aV);

/*
 * from fltrRep.c
 */
extern void		xpFltrRepRegisterCmds ARGS_TCL((Tcl_Interp *ip));
#endif /* _FILTER_H_ */
