#if !defined(_SILAR_H_)
#define _SILAR_H_ 1
/**
    RCS: $Header: /vol/cooley/cooley1/kennard/src/xpole/RCS/silar.h,v 1.5 93/08/27 14:28:02 kennard Exp $
    silar.h :: XPole

    Header for all silar-related stuff

    Author: Kennard White
    90/09/30 KDW: Created as zplane.c
    91/01/07 KDW: split into silar.h

    Copyright (c) 1990-93 The Regents of the University of California.
    All rights reserved.  See the file "./copyright.h" for full copyright
    notice, limitation of liability, and disclaimer of warranty provisions.
#include "copyright.h"				COPYRIGHTENDKEY
**/

#if !defined(_EEMSILAR_H_) && __TOP_AUTOINCLUDE__
#include "eemSilar.h"
#endif

typedef EEMSilarFlags XPSilarChangeMask;

#define XP_SilarIsDeadB(pSil) (			\
  ((pSil)==NULL) || ((pSil)->power == 0)	\
)

struct _XPSilarSnap {
    XPSilarView*	PntView;		/* must be first */
    XPViewPart*		PntVP;			/* must be second */
    EEMComplex		bbLo;
    EEMComplex		bbHi;
    EEMSilarGrp		Grp;
    XPSilarChangeMask	ChangeMask;
    XPSilarChangeMask	NextChangeMask;
};

/**
    This structure describes an entire silar database.  In general,
    this consists of a list of trajectories.  It also maintains all
    the state need for interactive editing of the silars.
**/
struct _XPSilarView /* derived(XPView) */ {
    XPView		DM;		/* Must be first */
};

#define XP_SILSET_Grp( pSR)	(&(pSR)->Grp)
#define XP_SILSET_Gain( pSR)	EEM_SILAR_Gain( &(pSR)->Grp)
#define XP_SILSET_Num( pSR)	EEM_SILAR_Num( &(pSR)->Grp)
#define XP_SILSET_Get(pSR, i)	EEM_SILAR_Get( (&(pSR)->Grp), i)

#if defined(__GNUC__)
#define XP_SILSET_PntRep(pSilar)	( (XPSilarSnap*) ((pSilar)->extra.pnt) )
#else
#define XP_SILSET_PntRep(pSilar)	( * (XPSilarSnap**) &((pSilar)->extra.pnt) )
#endif
#define XP_SILSET_PntDm(pSilar)	( XP_SILSET_PntRep(pSilar)->PntView )

#define XP_SILSET_IDX_LOOP_BEGIN( pSR, idxName, ptrName) \
    EEM_SILAR_IDX_LOOP_FORW_BEGIN( &(pSR)->Grp, idxName, ptrName)

#define XP_SILSET_IDX_LOOP_END() \
    EEM_SILAR_IDX_LOOP_FORW_END()

#define XP_SILSET_IDX_LOOP_BACK_BEGIN( pSR, idxName, ptrName) \
    EEM_SILAR_IDX_LOOP_BACK_BEGIN( &(pSR)->Grp, idxName, ptrName)

#define XP_SILSET_IDX_BACK_END() \
    EEM_SILAR_IDX_LOOP_BACK_END()

#define XP_SILSET_LOOP_BEGIN( pSR, ptrName)				\
    XP_SILSET_IDX_LOOP_BEGIN( (pSR), __xpsilrep_i_, ptrName)

#define XP_SILSET_LOOP_END() \
    XP_SILSET_IDX_LOOP_END() 



#ifdef notdef
#define XP_SILSET_IDXCHK( pSR, i) \
   ((0 <= (i)) && ((i) < XP_SILSET_Num(pSR)))


#define XP_SILSET_GETBYIDXSAFE( pSR, i) \
   ( XP_SILSET_IDXCHK((pSR),(i)) ? XP_SILSET_GETBYIDX((pSR),(i)) : NULL )
#endif

/*
 * silar.c
 */
extern XPViewClass	XpSilarViewClass;

extern void		xpSilarDmChange( XPSilarView *pDB, 
			  EEMSilarFlags mask);
extern void		xpSilarChange( XPSilar *pSilar, EEMSilarFlags mask);
extern XPSilarSnap*	xpSilarSnapCreate( XPSilarView *pDM, EEMComplex *pGain);
extern void		xpSilarSnapClear( XPSilarSnap *pSR, EEMComplex *pGain);
extern void		xpSilarSnapSetGain( XPSilarSnap *pSR, double r, double i);
extern void		xpSilarSnapInsertAtTail( XPSilarSnap *pSR, 
			  XPSilar *pSilar);
extern int		xpSilarSnapGetNum( XPSilarSnap *pSet);
extern void		xpSilarSnapSetNum( XPSilarSnap *pSR, int num);

extern void		xpSilarSnapInsureNum( XPSilarSnap *pRep, int num);
extern int		xpSilarSnapCalcRange( XPSilarSnap *pSR, 
			  EEMComplex *pLo, EEMComplex *pHi);
extern void		xpSilarSnapFreqResp( XPSilarSnap *pSR, 
			  EEMComplex *pFreq, EEMComplex *pResp);
extern void		xpSilarSnapSetPnts( XPSilarSnap *pSR);


extern XPSilar*		xpSilarCreateLoose( XPSilarView *pDB, char *name, 
			  EEMComplex *pLoc, int power, int flags);
extern XPSilar*		xpSilarCreate( XPSilarSnap *pSR, char *name, 
			  EEMComplex *pLoc, int power, int flags);

extern XPSilar*		xpSilarGetAvail( XPSilarSnap *pSR);
extern XPSilar*		xpSilarGetOrCreate( XPSilarSnap *pSR, int idx);

extern void		xpSilarMove( XPSilar *pSilar, double r, double i);
extern void 		xpSilarSetLocPower( XPSilar *pSilar, 
			  double r, double i, int power);
extern void		xpSilarConfig( XPSilar *pSilar, 
			  EEMComplex *pLoc, int power, int flags);
extern void		xpSilarCopyByIdx( XPSilarSnap *pSR, 
			  int idx, XPSilar *pSrcSilar);

extern void		xpSilarDestroy( XPSilar *pSilar);
extern void		xpSilarDestroyList( DLPtrListHandle silarList);
extern void		xpExportSilarToSep( XPSilar *pSilar);
extern XPSilar*		xpSilarFindByName( XPSilarSnap *pSR, char *name);
extern void		xpSilarSel( XPSilarView *pDB, 
			  XPSilar *pSilar, TOPLogical selB);
extern void		xpSilarSelSetOne( XPSilarView *pDB, 
			  XPSilar *pSilar, int AddB);
extern void		xpSilarSelSet( XPSilarView *pDB,
			  DLPtrListHandle pNewSet, TOPLogical AddB);
extern XPView*		xpSilarViewCreate( XPFilter* pFltr, char *name);
extern void		xpSilarViewDestroy( XPView *pDM);

extern XPSilarSnap*	xpSilarGetSnap( XPAgent *pAgent, XPGetSnapHow how);
extern XPSilarSnap*	xpSilarViewGetSnap( XPView *pView, XPGetSnapHow how);


/*
 * from silarTcl.c
 */
/*
extern XPSilarType	xpSilarTypeNameToType(char *name);
extern char*		xpSilarTypeToTypeName(XPSilarType t);
*/
extern char*		xpSilarToLocStr( XPSilar *pSilar);
extern char*		xpSilarToFlagStr( XPSilar *pSilar);
extern int		_xpSilarViewCmds( Tcl_Interp *ip, XPView *pGenDM,
			  char *cmd, int aC, char **aV);
extern int		_xpSilarNotifyTcl ARGS_TCL((XPView *pView, 
			  XPViewEvent ev,
			  XPViewSnap *pSnap, Tcl_Interp *ip, char *basecmd));
extern int		_xpSilarSnapCmdsPrs( XPSilarSnap *pSR, Tcl_Interp *ip, 
			  char *cmd, int aC, char **aV);


/*
 * from silarDh.c
 */
extern int		xpSilarDhRegisterCmds ARGS_TCL((Tcl_Interp *ip));
#endif /* _SILAR_H_ */
